######################################################################
# pyukiwiki.skin.ja.cgi - This is PyukiWiki, yet another Wiki clone.
# $Id: pyukiwiki.skin.ja.cgi,v 1.43 2006/02/05 06:04:34 papu Exp $
#
# "PyukiWiki" version 0.1.6-rc2 $$
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################

sub skin {
	my ($pagename, $body, $is_page, $bodyclass, $editable, $admineditable, $basehref) = @_;

	my($page,$message,$errmessage)=split(/\t/,$pagename);	
	my $cookedpage = &encode($page);
	my $cookedurl=&make_cookedurl($cookedpage);
	my $escapedpage = &htmlspecialchars($page);
	my $HelpPage = &encode($::resource{help});
	my $htmlbody;
	my ($title,$headerbody,$menubarbody,$footerbody,$notesbody);

	# last_modifiedHTML
	if ($::last_modified != 0) {	# v0.0.9
		$lastmod = &date($::lastmod_format, (stat($::data_dir . "/" . &dbmname($page) . ".txt"))[9]);
	}

	# CSS̐ݒ
	if($::lang eq 'ja') {
		$csscharset=qq( charset="Shift_JIS");
	}
	if($::use_blosxom eq 1) {
		$::IN_HEAD.=<<EOD;
<link rel="stylesheet" href="$::skin_url/blosxom.css" type="text/css" media="screen"$csscharset />
EOD
	}

	# <title>^O̐
	if($::wiki_title ne '') {
		$title="$::wiki_title - ";
	}

	if($page eq '') {
		$title_tag="$title$message";
	} else {
		$title_tag="$title$escapedpage @{[&htmlspecialchars(&get_subjectline($page))]}";
	}

	# MenuBar, :Header, :FooterHTML
	if($is_page || $::allview eq 1) {
		$headerbody=&print_content($::database{$::Header}, $::form{mypage})
			if(&is_exist_page($::Header));
		$::pushedpage = $::form{mypage};	# push;
		$::form{mypage}=$::MenuBar;
		$menubarbody=&print_content($::database{$::MenuBar}, $::pushedpage)
			if(&is_exist_page($::MenuBar));
		$::form{mypage}=$::pushedpage;	# pop;
		$::pushedpage="";
		$footerbody=&print_content($::database{$::Footer}, $::form{mypage})
			if(&is_exist_page($::Footer));
	}

	# HTML̐
	if (@::notes) {
		$notesbody.= << "EOD";
<div id="note">
<hr class="note_hr" />
EOD
		my $cnt = 1;
		foreach my $note (@::notes) {
			$notesbody.= << "EOD";
<a id="notefoot_$cnt" href="@{[&make_cookedurl($::form{mypage})]}#notetext_$cnt" class="note_super">*$cnt</a>
<span class="small">@{[&inline($note)]}</span>
<br />
EOD
			$cnt++;
		}
		$notesbody.="</div>\n";
	}

	# HTML <head>`</head> A摜N܂
	$htmlbody=<<"EOD";
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="$::lang">
<head>
<meta http-equiv="Content-Language" content="$::lang">
<meta http-equiv="Content-Type" content="text/html; charset=$::charset">
<meta http-equiv="Content-Style-Type" content="text/css">
<meta http-equiv="Content-Script-Type" content="text/javascript">
<title>$title_tag</title>
@{[$basehref eq '' ? '' : qq(<base href="$basehref">)]}
<meta name="generator" content="PyukiWiki $::version">
@{[-r "$::skin_dir/$::skin{default_css}" ? qq(<link rel="stylesheet" href="$::skin_url/$::skin{default_css}" type="text/css" media="screen"$csscharset />) : '']}
@{[-r "$::skin_dir/$::skin{print_css}" ? qq(<link rel="stylesheet" href="$::skin_url/$::skin{print_css}" type="text/css" media="print"$csscharset />) : '']}
@{[$::AntiSpam ne "" ? '' : qq(<link rev="made" href="mailto:$::modifier_mail">)]}
<link rel="top" href="$::script">
<link rel="index" href="$::script?cmd=list">
@{[$::use_SiteMap eq 1 ? qq(<link rel="contents" href="$::script?cmd=sitemap">) : '']}
<link rel="search" href="$::script?cmd=search">
<link rel="help" href="$::script?$HelpPage">
<meta name="description" content="$title$escapedpage @{[&htmlspecialchars(&get_subjectline($page))]}">
<meta name="author" content="$::modifier">
<meta name="copyright" content="$::modifier">
@{[-r "$::skin_dir/$::javascript{common}" ? qq(<script type="text/javascript" src="$::skin_url/$::javascript{common}"></script>) : '']}
@{[-r "$::skin_dir/$::javascript{default}" ? qq(<script type="text/javascript" src="$::skin_url/$::javascript{default}"></script>) : '']}
$::IN_HEAD
</head>
<body class="$bodyclass">
<div id="header">
<a href="$::modifierlink"><img id="logo" src="$::image_url/pyukiwiki.png" width="80" height="80" alt="[PyukiWiki]" title="[PyukiWiki]" /></a>
EOD

	# y[W^CgAbZ[W̕\
	if($errmessage ne '') {
		$htmlbody.=<<EOD;
<h1 class="error">$errmessage</h1>
<a href="$cookedurl">$basehref?$cookedpage</a>
EOD
	} elsif($page ne '') {
		$htmlbody.=<<EOD;
<h1 class="title"><a
    title="$::resource{searchthispage}"
    href="$::script?cmd=search&amp;mymsg=$cookedpage">@{[&htmlspecialchars($page)]}</a>@{[$message eq '' ? '' : "&nbsp;$message"]}</h1>
<span class="small"><a href="$cookedurl">$basehref?$cookedpage</a></span>
EOD
	} else {
		$htmlbody.=<<EOD;
<h1 class="title">$message</h1>
EOD
	}

	# irQ[^̕\
	$htmlbody.=<<EOD;
</div>
<div id="navigator">

 [ <a href="$cookedurl">$::resource{reload}</a> ]
 &nbsp;
 [ <a href="$::script?cmd=newpage&amp;refer=$cookedpage">$::resource{createbutton}</a>
 @{[ $editable
   ? qq( | <a title="$::resource{editthispage}" href="$::script?cmd=edit&amp;mypage=$cookedpage">$::resource{editbutton}</a>)
   : qq()
 ]}
 @{[ $admineditable
   ? qq( | <a title="$::resource{admineditthispage}" href="$::script?cmd=adminedit&amp;mypage=$cookedpage">$::resource{admineditbutton}</a>)
   : qq()
 ]}
 @{[ $admineditable
   ? qq( | <a href="$::script?cmd=diff&amp;mypage=$cookedpage">$::resource{diffbutton}</a>)
   : qq()
 ]}
 @{[ (-f "$::plugin_dir/attach.inc.pl" && $::file_uploads > 0)
   ? qq( | <a href="$::script?cmd=attach&amp;mypage=$cookedpage">$::resource{attachbutton}</a>)
   : qq()
 ]}
 ]
 &nbsp;
 [ <a href="@{[&make_cookedurl($::FrontPage)]}">$::resource{top}</a> | 
   <a href="$::script?cmd=list">$::resource{indexbutton}</a> | 
 @{[ $::use_SiteMap eq 1
   ? qq(<a href="$::script?cmd=sitemap">$::resource{sitemapbutton}</a> | )
   : qq()
 ]}
   <a href="$::script?cmd=search">$::resource{searchpage}</a> |
   <a href="$::script?cmd=recent">$::resource{recentchangesbutton}</a> |
   <a href="@{[&make_cookedurl($HelpPage)]}">$::resource{help}</a> ]
</div>
<hr class="full_hr" />
@{[ $::last_modified == 1
  ? qq(<div id="lastmodified">$::lastmod_prompt $lastmod</div>)
  : q()
]}
EOD

	# :Header̕\
	$htmlbody.=$headerbody if ($headerbody);

	# table`
	$htmlbody.= <<"EOD";
<table border="0" style="width:100%">
  <tr>
EOD

	# MenuBar̕\
	if($menubarbody ne '') {
		$htmlbody.=<<"EOD";
    <td class="menubar" valign="top">
    <div id="menubar">
$menubarbody
    </div>
    </td>
EOD
	}

	# Rec̕\
	$htmlbody.= <<"EOD";
    <td valign="top">
      <div id="body">$body</div>@{[$::notesview eq 0 ? $notesbody : '']}
    </td>
  </tr>
</table>@{[$::notesview eq 1 ? $notesbody : '']}
EOD

	# :Footer y[W
	$htmlbody.=$footerbody if ($footerbody);

	# ߂̕\i:Footer̉j
	$htmlbody.=$::notesview eq 2 ? $notesbody : '';

	# ACRAlastmodified\
	$htmlbody.= <<"EOD";
<hr class="full_hr" />
<div id="toolbar"><a href="$::script?cmd=rss10"><img src="$::image_url/rss.png" alt="RSS" /></a></div>
@{[ $::last_modified == 2
 ? qq(<div id="lastmodified">$::lastmod_prompt $lastmod</div>)
 : qq()
]}
<div id="footer">
EOD

	# y[Wtb^ wiki@
	$footerbody=<<EOD;
@{[$::wiki_title ne '' ? qq(''[[$::wiki_title>$basehref]]'' ) : '']}Modified by [[$::modifier>$::modifierlink]]~
~
''[[PyukiWiki $::version>http://pyukiwiki.sourceforge.jp/]]''
Copyright&copy; 2004-2006 by [[Nekyo>http://nekyo.hp.infoseek.co.jp/]], [[PyukiWiki Developers Team>http://pyukiwiki.sourceforge.jp/]]
License is [[GPL>http://www.opensource.jp/gpl/gpl.ja.html]], [[Artistic>http://www.opensource.jp/artistic/ja/Artistic-ja.html]]~
Based on "[[YukiWiki>http://www.hyuki.com/yukiwiki/]]" 2.1.0 by [[yuki>http://www.hyuki.com/]]
and [[PukiWiki>http://pukiwiki.sourceforge.jp/]] by [[PukiWiki Developers Term>http://pukiwiki.sourceforge.jp/]]
EOD
	$htmlbody.= &text_to_html($footerbody);

	$htmlbody.= <<"EOD";
@{[&convtime]}
</div>
</body>
</html>
EOD
	return $htmlbody;
}

1;
