######################################################################
# new.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id: new.inc.pl,v 1.29 2006/02/10 06:49:31 papu Exp $
#
# "PyukiWiki" version 0.1.6-rc3 $$
# Author: Nekyo
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################

my $new_dates_short=1*24*60*60;
my $new_dates_long=5*24*60*60;
my $new_string_short=' <span class="new1">New!</span>';
my $new_string_long=' <span class="new5">New</span>';

sub plugin_new_inline {
	my $date = shift;
	if ($date eq '') { return ''; }

	my $retval = $date;
	my ($mday, $mon, $year) = (localtime())[3..5];

	my $now = &mktime(0, 0, 0, $mon + 1, $mday, $year + 1900);
	$date =~ /(\d+)-(\d+)-(\d+)/;
	my $past = &mktime(0, 0, 0, $2, $3, $1);

	if (($now - $past) <= $new_dates_short) {
		$retval .= $new_string_short;
	} elsif (($now - $past) <= $new_dates_long) {
		$retval .= $new_string_long;
	}
	return '<span class="comment_date">' . $retval . '</span>';
}
1;
__END__

=head1 NAME

new.inc.pl - PyukiWiki Plugin

=head1 SYNOPSIS

 &new{2006-01-01 (Sun) 00:00:00};

=head1 DESCRIPTION

When the specified contents are less than regular dates, it is displayed as New.

=head1 USAGE

 &new(date-format);

=head1 SETTING

=over 4

=item my $new_dates_short

Setup regular dates of print 'New!'

=item my $new_dates_long

Setup regular dates of print 'New'

=item my $new_string_short

Setting displayed text which time of setuped by $new_dates_short.

=item my $new_string_long

Setting displayed text which time of setuped by $new_dates_long.

=back

=head1 SEE ALSO

=over 4

=item PyukiWiki/Plugin/Standard/new

L<http://pyukiwiki.sourceforge.jp/cgi-bin/w/PyukiWiki/Plugin/Standard/new/>

=item PyukiWiki CVS

L<http://cvs.sourceforge.jp/cgi-bin/viewcvs.cgi/pyukiwiki/PyukiWiki-Devel/plugin/new.inc.pl>

=back

=head1 AUTHOR

=over 4

=item Nekyo

L<http://nekyo.hp.infoseek.co.jp/>

=item PyukiWiki Developers Team

L<http://pyukiwiki.sourceforge.jp/>

=back

=head1 LICENSE

Copyright (C) 2004-2006 by Nekyo.

Copyright (C) 2005-2006 by PyukiWiki Developers Team

License is GNU GENERAL PUBLIC LICENSE 2 and/or Artistic 1 or each later version.

This program is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut
