######################################################################
# perlpod.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id: perlpod.inc.pl,v 1.32 2006/02/19 05:06:05 papu Exp $
#
# "PyukiWiki" version 0.1.6-rc4-p3 $$
# Author: Nanami http://lineage.netgamers.jp/
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################

require 'plugin/contents.inc.pl';

sub plugin_perlpod_action {
	my $file;
	$file=$::form{file};
	return if($file=~/\.\./ || $file=~/^\// || $file=~/[|><%'"]/);
	return('msg'=>"\t$::$file"
		,'body'=>&perlpod($file));
}

sub plugin_perlpod_convert {
	my $file;

	my @args=split(/,/,shift);
	$file=$args[0];
	$notitle=$args[1];

	return if($file=~/\.\./ || $file=~/^\// || $file=~/[|><%'"]/);

	return(&perlpod($file,$notitle ne '' ? "notitle" : ""));
}

sub getperlpath{
	my $perlpath;
	if(open(R,"$0")) {
		$perlpath=<R>;
		close(R);
		$perlpath=~s/#!//g;
		$perlpath=~s/-//g;
		$perlpath=~s/ //g;
		$perlpath=~s/[\r\n]//g;
		return $perlpath;
	}
	return '';
}

sub perlpod {
	my($file,$notitle)=@_;
	$file=~s/.*\///g;

	foreach my $dirs($::data_home, $::data_pub, $::explugin_dir, $::plugin_dir
			, $::res_dir, $::skin_dir, $::image_dir) {
		if(-r "$dir/$file") {
			return &perlpod_sub("$dir/$file",$notitle);
		}
	}
	foreach my $dirs($::explugin_dir, $::plugin_dir, $::res_dir, $::skin_dir, $::data_home, $::data_pub) {
		my $ret=&perlpod_sub2($dirs,$file);
		if($ret ne '') {
			return &perlpod_sub($ret,$notitle);
		}
	}
	return("File nod found:$file");
}

my $level=0;

sub perlpod_sub2 {
	my($dir,$file)=@_;

	opendir(DIR,$dir);
	my @files=readdir(DIR);
	closedir(DIR);

	foreach(@files) {
		next if($_ eq '.' || $_ eq '..');
		my $path="$dir/$_";
		return $path if($_ eq $file);
		if(-d $path) {
			$level++;
			return '' if($level > 10);
			my $ret=&perlpod_sub2($path,$file);
			return $ret if($ret ne '');
			$level--;
		}
	}
	return "";
}

sub perlpod_sub {
	my $file=shift;
	my $notitle=shift;
	my $body="";
	my $pod='';
	my $name="";
	my $tmp;
	my ($cmd,$data);
	my $anchor=0;

	$::interwiki_definition="";
	$::interwiki_definition2="";
	if(!open(R,$file)) {
		return("File not found : $file");
	}
	foreach $f(<R>) {
		chomp $f;
		if($f=~/^=/ && $pod eq '') {
			$pod="pod";
		}
		next if(f=~/^__/ || $pod eq '');
		if($f=~/^=cut/) {					# podI
			$pod='';
			next;
		} elsif($f eq '') {				# s
			if($pod=~/wiki/) {
				$body.="\n";
			} elsif($pod eq 'dd') {
				$body.="&br;&br;";
			} elsif(!($pod eq 'name' || $pod=~/^d[d|t|l]/)) {
				$body.="\n\n";
				$pod='pod';
			} elsif($pod=~/for/) {
				$pod="pod";
			}
			next;
		}
		if($f!~/^\s/ && $pod!~/wiki/) {
			$f=~s/\#/\x5/g;
			$f=~s/\&/\&#x26;/g;
			$f=~s/\x5/\&#x23;/g;
			$f=~s/\$/\&#x24;/g;
			$f=~s/\:\/\//\x8/g;
			$f=~s/\:/\&#x3a;/g;
		}
		$f=~s/\@/\&#x40;/g;
		$f=~/^=([^\s]+)(.*)/;
		$cmd=$1;
		$data=$2;
		$data=~s/^\s*//g;
		if($f=~/^=encoding/) {
			next;
		} elsif($cmd eq 'lang') {
			next;
		} elsif($cmd eq 'head1' && $data eq 'NAME') {	# NAMEʏ
			$pod='name';
			next;
		} elsif($pod eq 'name') {
			$body.="**NAME\n" . &perlpod_tags($f);
			$name=&perlpod_tags($f);
			$anchor++;
			$pod="pod";
			next;
		} elsif($cmd eq 'head1') {	# body 1
			$pod="pod";
			$body.="**" . &perlpod_tags($data) . "\n";
			$anchor++;
		} elsif($cmd eq 'head2') {	# body 2
			$pod="pod";
			$body.="***" . &perlpod_tags($data) . "\n";
			$anchor++;
		} elsif($cmd eq 'for') {		# ̃ubNw肵tH[}bg
			if($data eq 'wiki') {
				$pod='for_wiki';
			} else {
				next;
			}
		} elsif($cmd eq 'begin') {		# =end܂Ŏw肵tH[}bg
			if($data eq 'wiki') {
				$pod='begin_wiki';
			} else {
				next;
			}
		} elsif($cmd eq 'end') { 		# w肵tH[}bgI{
			$pod="pod";
		} elsif($pod=~/wiki/) {			# wiki@̂܂܊i[
			$body.="$f\n";
		} elsif($cmd eq 'over') {	# dlJn
			$pod="dl";
		} elsif($cmd eq 'back') {	# dl
			$pod="pod";
		} elsif($cmd eq 'item') {	# dt
			$body=~s/\&br;$//g while($body=~/\&br;$/);
			$body.="&nbsp;" if($pod=~/d[dt]/);
			$body.="\n:" . &perlpod_tags($data) . ":";
			$pod="dt";
		} elsif($pod=~/d[dt]/) {		# dd
			if($f=~/^\s/) {
				$body.="\n" if($pod eq "dd");
				$body.="$f\n";
				$pod="ddpre";
			} else {
				$pod="dd";
				if($pod=~/pre/) {
					$body.=":&nbsp;:";
				}
				$body.=&perlpod_tags($f);
			}
		} else {
			if($f=~/^\s/) {
				$body.="$f\n";
			} else {
				$body.=&perlpod_tags($f);
			}
		}
	}

	$body=~s/\x8/\:\/\//g;
	if($notitle eq '') {
		$html=&text_to_html("*$name\n\perlpoddummycontents\n----\n$body");
		my $contents=&plugin_contents_main("?$ENV{QUERY_STRING}",split(/\n/,"*$name\n\perlpoddummycontents\n----\n$body"));
		$html=~s!perlpoddummycontents!$contents!g;
	} else {
		$html=&plugin_contents_main("?$ENV{QUERY_STRING}",split(/\n/,$body));
		$html.=&text_to_html("----\n$body");
	}
	return $html;
}

sub perlpod_tags {
	my($str)=@_;

	$str=~s/L<\/([^>]+)>/$1/g;	# link
	$str=~s/L<([^>]+)>/[[$1]]/g;	# link
	$str=~s/I<([^>]+)>/'''$1'''/g;
	$str=~s/B<([^>]+)>/''$1''/g;
	$str=~s/S<([^>]+)>/\&verb($1);/g;
	$str=~s/C<([^>]+)>/$1/g;	# typewriter or program text font
	$str=~s/F<([^>]+)>/$1/g;	# filename
	$str=~s/X<([^>]+)>/$1/g;	# ̃Gg
	$str=~s/Z<([^>]+)>/$1/g;	# [̃LN^[
	$str=~s/E<lt>/</g;
	$str=~s/E<gt>/>/g;
	$str=~s/E<sol>/\//g;
	$str=~s/E<verbar>/\|/g;
	$str=~s/E<\d+>/chr($1)/gex;
	# E<html>
	return $str;
}

1;
__END__

=head1 NAME

perlpod.inc.pl - PyukiWiki Plugin

=head1 SYNOPSIS

 ?cmd=perlpod&file=perl script file or pod file.
 #perlpod(perl script file or pod file.)

=head1 DESCRIPTION

View perl document of pod

A directory cannot be specified because of the measure against security.

Automatically Recursive search of the bottom of the directory setup by pyukiwiki.ini.cgi.

=head1 SEE ALSO

=over 4

=item PyukiWiki/Plugin/Standard/perlpod

L<http://pyukiwiki.sourceforge.jp/cgi-bin/w/PyukiWiki/Plugin/Standard/perlpod/>

=item PyukiWiki CVS

L<http://cvs.sourceforge.jp/cgi-bin/viewcvs.cgi/pyukiwiki/PyukiWiki-Devel/plugin/perlpod.inc.pl>

=back

=head1 AUTHOR

=over 4

=item Nanami

L<http://lineage.netgamers.jp/> etc...

=item PyukiWiki Developers Team

L<http://pyukiwiki.sourceforge.jp/>

=back

=head1 LICENSE

Copyright (C) 2005-2006 by Nanami.

Copyright (C) 2005-2006 by PyukiWiki Developers Team

License is GNU GENERAL PUBLIC LICENSE 2 and/or Artistic 1 or each later version.

This program is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut
